//---------------------------------------------------------------- -o--
// GalacticNumberTest.java 
// 
// TEST METHODS--
//   testCreateAndRetrieve()
//
//
// @version 0.1
//

import java.lang.*;
import java.io.*;
import java.util.*;

import junit.framework.*;
import org.junit.*;
import org.apache.commons.io.*;
import org.hamcrest.*;



//----------------------------------------------------------------- -o--
public class GalacticNumberTest extends TestCase
{
  // Test methods.
  //

  //------------------------------ -o-
  @org.junit.Test
  public void  testCreateAndRetrieve()
  {
    String  existingGalacticNumber     = "kirk";
    String  nonExistingGalacticNumber  = "frodo";

    String       existingRomanNumber  = "X";
    RomanNumber  actualRomanNumber    = RomanNumber.X;

    Boolean  constructorWorked;


    // Bad input.
    //

    try {
      constructorWorked = true;
      GalacticNumber.mapFromRomanNumber(existingGalacticNumber, null);

    } catch (GTException e) {
      constructorWorked = false;
    }

    assertTrue( "GalacticNumber(string, null) FAILED.", ! constructorWorked ); 


    //
    try {
      constructorWorked = true;
      GalacticNumber.mapFromRomanNumber(null, existingRomanNumber);

    } catch (GTException e) {
      constructorWorked = false;
    }

    assertTrue( 
      "GalacticNumber(null, string) FAILED.", ! constructorWorked ); 


    //
    try {
      constructorWorked = true;
      GalacticNumber.mapFromRomanNumber("", existingRomanNumber);

    } catch (GTException e) {
      constructorWorked = false;
    }

    assertTrue( 
      "GalacticNumber(\"\", RomanNumber) FAILED.", ! constructorWorked ); 



    // Create and retrieve.
    //
    constructorWorked = false;

    try {
      GalacticNumber.mapFromRomanNumber(
      				existingGalacticNumber, existingRomanNumber);
      constructorWorked = true;

    } catch (GTException e) {
      constructorWorked = false;
    }

    assertTrue( 
      "GalacticNumber(string, RomanNumber) SUCCEEDED.", constructorWorked ); 


    //
    assertTrue( 
      "GalacticNumber.isNumber(existingGalacticNumber) SUCCEEDED.", 
      GalacticNumber.isNumber(existingGalacticNumber) ); 
    
    assertTrue( 
      "GalacticNumber.isNumber(nonExistingGalacticNumber) FAILED.", 
      ! GalacticNumber.isNumber(nonExistingGalacticNumber) ); 


    //
    RomanNumber retrievedRN = 
        	    GalacticNumber.asRomanNumber(existingGalacticNumber);

    assertTrue( 
      "Retrieving RomanNumber from arbitrary GalacticNumber is a SUCCESS.",
      retrievedRN.equals(actualRomanNumber) );

  } // testCreateAndRetrieve()


} // class GalacticNumberTest

